#include <porty/c99tree-cc/c99tree-cc.h>

struct c99c_scope_s {
	htsp_t *typedefs;             /* typename -> type declaration subtree clone for typedefs*/
	htsp_t *negative_typedefs;    /* typename -> (1) for those IDs which are typedef'd in parent scopes but redeclared as variables in the current scope */
	c99c_node_t *compound;             /* pointer for return node of a compound being assambled */
	c99c_scope_t *parent, *child;
};

/* enter a new scope (upon '{') */
void c99c_scope_enter(c99tree_cc_t *ctx);

/* leave current scope (upon '}') */
void c99c_scope_leave(c99tree_cc_t *ctx);

/* register a typedef */
void c99c_scope_add_typedef(c99tree_cc_t *ctx, const char *name, c99c_node_t *new);

/* get a type subtree by "type" if "type" is a typedef'd type in the current
   scope or any parent of the current scope */
const c99c_node_t *c99c_scope_get_typedef(c99tree_cc_t *ctx, const char *type);

/* create a typedef */
void c99c_scope_typedef_add(c99tree_cc_t *ctx, c99c_node_t *type, c99c_node_t *ids);

/* create a negative typedef */
void c99c_scope_negative_typedef_add(c99tree_cc_t *ctx, const char *name);

